CHAR - Draw a character string on a graphic screen


 CHAR column, row, height, width, direction, "string" [,charsetadr [,bank]]


	column:		Character column	(for 320 wide screens, 0-39)
						(for 640 wide screens, 0-79)

	row:		Pixel line		(for 200 line screens, 0-199)
						(for 400 line screens, 0-399)

	height:		Multiple of 8-bit character height
						(1=normal, 8 pixels high)
						(2=double height, etc.)

	width:		Multiple of 8-bit character width
						(1=normal, 8 pixels wide)
						(2=double width, etc.)

	direction:	Angle of character line, specified as a bit mask
			where B0=up, B1=right, B2=down, and B3=left.

					1
				   9	|    3
				     \     /
				 8 --   +   -- 2
				     /     \
	                          12    |    6
					4
			

CHAR is used to draw characters on the graphic draw screen at the specified
location using the currently defined draw PEN.  The character height, width,
orientation and direction are programmable.

The CHAR string is composed of PETSCII text and graphic characters.  The CHAR
string may contain special control characters to modify the output or its
placement.  More than one control code can be in effect at the same time.  In
addition to the cursor controls (up,down,left,right,home), the following
control codes are recognized (all others are ignored):

   KEY    CHR$	Effect
  -----  ------	-------------------------------------------------
   ^B	  2	Blank area on screen before drawing characters
   ^F	  6	Flip characters upside down (toggle)
   ^Y	 25	Tilt OFF
   ^Y-		 Tilt characters on back (rotate counterclockwise 90 )
   ^Y+		 Tilt characters on face (rotate clockwise 90 )
   ^Z	 26	Mirror image (toggle)

   ^R	 18	Reverse field ON
	146	Reverse field OFF
   ^U	 21	Underline (toggle)

   ^I	  9	AND cells with character data
   ^O	 15	OR  cells with character data
   ^X	 24	XOR cells with character data


The control codes remain in effect for the entire CHAR string or until they
are turned off.  The boolean codes (and, or, xor) modify the color index,
based upon the current PEN color value.  They are particularly useful for
monochrome screens or creating specialized effects such as "rainbow fonts".
The default mode is to place the foreground text over any screen data, using
the current PEN color.

The default image for each 8x8 pixel character comes from the system character
ROM at $29800 (charsetadr=DEC("9800"), bank=2), which is the National
upper/lowercase character set.  Character sets available in the system ROM are:

	$29800 (the National upper/lowercase set)
	$29000 (the National uppercase/graphic set)
	$2D000 (the C64 upper/lowercase set)
	$2D800 (the C64 uppercase/graphic set)

If a bank number is not specified, 2 is assumed.  It's possible to copy a
character set to RAM, customize it, and use it for CHAR.


	CHAR 18,96,1,1,2,"C64DX"		draws c64dx in center of a
						low resolution screen

	CHAR 0,0,1,2,2,"C64DX",DEC("9000")	draws C64DX at top left corner
						of a graphic screen, using
						double wide characters from the
						uppercase/graphic character set

	CHAR x,y,1,1,2,"Blabel",DEC("8000"),0	draws the entire character cell
						(foreground & background) on a
						graphic screen (B=^B), using a
						custom character set loaded in
						bank 0 RAM at $8000.
