	Appendix F.	PETSCII Characters Codes			910805
									F.Bowen
	This table shows you what characters will appear or what
	screen editor function is performed if you PRINT CHR$(x) for
	all 256 possible values of x (0-255), or what value you will
	get if you PRINT ASC(x$) for any string character.  This
	is useful for evaluating keyboard characters received in a
	GET x$ statement.

	To tell which mode, uppercase/graphics or upper/lowercase,
	the system is in, test bit-2 of either VIC register #24
	(53272, $D018) or system variable VM1 (4388, $1124):

		    BANK 128: ? PEEK (DEC("1124")) AND 2

		    result	0= uppercase/graphics mode
				2= upper/lowercase mode

	To tell what National keyboard is present, examine ROM location
	$03FC00 (bank 3, address 64512):

		    BANK 3: ? PEEK (DEC("FC00"))

		    result	0= US/English keyboard
				1= German/Austrian keyboard
	    (note other versions may be added from time to time)

	If the C64DX is equipped with a national keyboard ($FC00<>0),
	to tell which keyboard mode (national or other)	the editor is in,
	examine the ASC/DIN key I/O location $D607 (54791) and check to
	see if the national mode has been disabled ($111E, 4382):

		    BANK 128: ? PEEK (DEC("D607")) AND 1

		    result	0= National mode (ASC/DIN key down)
				1= "normal" mode (ASC/DIN key up)

		    BANK 128: ? PEEK (DEC("111E"))

		    result	0  = National mode enabled
				128= National mode disabled



       CHR$ or ASC code			     Description
       ----------------		---------------------------------------
	 HEX	 DEC		set-1	set-2	set-3	set-4	ASCII-7
	-----	-----		-----	-----	-----	-----	-------
	 00	  0			null			ctrl-@
	 01	  1						ctrl-A
	 02	  2			underline on		ctrl-B
	 03	  3			(stop key)		ctrl-C
	 04	  4						ctrl-D
	 05	  5			white			ctrl-E
	 06	  6						ctrl-F
	 07	  7			bell			ctrl-G
	 08	  8						ctrl-H
	 09	  9			tab			ctrl-I
	 0A	 10			linefeed		ctrl-J
	 0B	 11			lock case		ctrl-K
	 0C	 12			unlock case		ctrl-L
	 0D	 13			return			ctrl-M
	 0E	 14			upper/lowercase mode	ctrl-N
	 0F	 15			flash on		ctrl-O

	 10	 16			F9    (autoscroll up)	ctrl-P
	 11	 17			cursor down		ctrl-Q
	 12	 18			reverse on		ctrl-R
	 13	 19			home  (pause)		ctrl-S
	 14	 20			delete			ctrl-T
	 15	 21			F10   (word back)	ctrl-U
	 16	 22			F11   (autoscroll down)	ctrl-V
	 17	 23			F12   (word advance)	ctrl-W
	 18	 24			set tabstop		ctrl-X
	 19	 25			F13			ctrl-Y
	 1A	 26			F14   (backtab)		ctrl-Z
	 1B	 27			escape			ctrl-[
	 1C	 28			red			ctrl-\
	 1D	 29			cursor right		ctrl-]
	 1E	 30			green			ctrl-^
	 1F	 31			blue			ctrl-_

	 20	 32			space			space
	 21	 33			!			!
	 22	 34			"			"
	 23	 35			#			#
	 24	 36			$			$
	 25	 37			%			%
	 26	 38			&			&
	 27	 39			'			'
	 28	 40			(			(
	 29	 41			)			)
	 2A	 42			*			*
	 2B	 43			+			+
	 2C	 44			,			,
	 2D	 45			-			-
	 2E	 46			.			.
	 2F	 47			/			/

	 30	 48			0			0
	 31	 49			1			1
	 32	 50			2			2
	 33	 51			3			3
	 34	 52			4			4
	 35	 53			5			5
	 36	 54			6			6
	 37	 55			7			7
	 38	 56			8			8
	 39	 57			9			9
	 3A	 58			:			:
	 3B	 59			;			;
	 3C	 60			<			<
	 3D	 61			=			=
	 3E	 62			>			>
	 3F	 63			?			?

	 40	 64		@	@			@
	 41	 65		A	a	A	a	A
	 42	 66		B	b	B	b	B
	 43	 67		C	c	C	c	C
	 44	 68		D	d	D	d	D
	 45	 69		E	e	E	e	E
	 46	 70		F	f	F	f	F
	 47	 71		G	g	G	g	G
	 48	 72		H	h	H	h	H
	 49	 73		I	i	I	i	I
	 4A	 74		J	j	J	j	J
	 4B	 75		K	k	K	k	K
	 4C	 76		L	l	L	l	L
	 4D	 77		M	m	M	m	M
	 4E	 78		N	n	N	n	N
	 4F	 79		O	o	O	o	O

	 50	 80		P	p	P	p	P
	 51	 81		Q	q	Q	q	Q
	 52	 82		R	r	R	r	R
	 53	 83		S	s	S	s	S
	 54	 84		T	t	T	t	T
	 55	 85		U	u	U	u	U
	 56	 86		V	v	V	v	V
	 57	 87		W	w	W	w	W
	 58	 88		X	x	X	x	X
	 59	 89		Y	y	Y	y	Y
	 5A	 90		Z	z	Z	z	Z
	 5B	 91		[	[	[	[	[
	 5C	 92				\	\	\
	 5D	 93		]	]	]	]	]
	 5E	 94						^
	 5F	 95						_

	 60	 96				`	`	`
	 61	 97			A		A	a
	 62	 98			B		B	b
	 63	 99			C		C	c
	 64	100			D		D	d
	 65	101			E		E	e
	 66	102			F		F	f
	 67	103			G		G	g
	 68	104			H		H	h
	 69	105			I		I	i
	 6A	106			J		J	j
	 6B	107			K		K	k
	 6C	108			L		L	l
	 6D	109			M		M	m
	 6E	110			N		N	n
	 6F	111			O		O	o

	 70	112			P		P	p
	 71	113			Q		Q	q
	 72	114			R		R	r
	 73	115			S		S	s
	 74	116			T		T	t
	 75	117			U		U	u
	 76	118			V		V	v
	 77	119			W		W	w
	 78	120			X		X	x
	 79	121			Y		Y	y
	 7A	122			Z		Z	z
	 7B	123						{
	 7C	124						|
	 7D	125						}
	 7E	126						~
	 7F	127						delete

	 80	128						
	 81	129			orange			
	 82	130			underline off		
	 83	131			(run key)		
	 84	132			(help key)		
	 85	133			F1			
	 86	134			F3			
	 87	135			F5			
	 88	136			F7			
	 89	137			F2			
	 8A	138			F4			
	 8B	139			F6			
	 8C	140			F8			
	 8D	141			shifted return		
	 8E	142			uppercase/graphic mode	
	 8F	143			flash off		

	 90	144			black			
	 91	145			cursor up		
	 92	146			reverse off		
	 93	147			clear			
	 94	148			insert			
	 95	149			brown			
	 96	150			lt. red			
	 97	151			dk. gray		
	 98	152			md. gray		
	 99	153			lt. green		
	 9A	154			lt. blue		
	 9B	155			lt. gray		
	 9C	156			purple			
	 9D	157			cursor left		
	 9E	158			yellow			
	 9F	159			cyan			

	 A0	160			shifted space		
	 A1	161					
	 A2	162					
	 A3	163					
	 A4	164					
	 A5	165					
	 A6	166					
	 A7	167					
	 A8	168					
	 A9	169					
	 AA	170					
	 AB	171					
	 AC	172					
	 AD	173					
	 AE	174					
	 AF	175					

	 B0	176					
	 B1	177					
	 B2	178					
	 B3	179					
	 B4	180					
	 B5	181					
	 B6	182					
	 B7	183					
	 B8	184					
	 B9	185					
	 BA	186					
	 BB	187					
	 BC	188					
	 BD	189					
	 BE	190					
	 BF	191					

	PETSCII	Codes	$C0-$DF (192-223)  same as  $60-$7F ( 96-127)
	PETSCII	Codes	$E0-$FE (224-254)  same as  $A0-$FE (160-190)
	PETSCII	Code	$FF	(255)	   same as  $7E	    (126)
