


The Kernel maintains a configuration table in RAM-0 for the BASIC, Monitor, and DOS environments.  Refer to
the Memory Mapper section of Appendix K for a description of the memory mapper.  The configuration table is:

BASIC	   $000110:	a  00	$0000-$1FFF is unmapped (RAM-0)
			x  E3	$2000-$7FFF is mapped from $032000-$037FFF
			y  00	$8000-$BFFF & $E000-$FFFF are mapped from $038000-$03BFFF & $03E000-$03FFFF
			z  B3	$C000-$DFFF is unmapped (ROM-2 & I/O)

Monitor	   $000114:	a  A0	$0000-$5FFF is unmapped (RAM-0)
			x  82	$6000-$7FFF is mapped from $030000-$031FFF
			y  00	$8000-$DFFF is unmapped (RAM-0, ROM-2, & I/O)
			z  83	$E000-$FFFF is mapped from $03E000-$03FFFF

DOS	   $000118:	a  00	$0000-$1FFF is mapped from $010000-$011FFF
			x  11	$2000-$7FFF is unmapped (RAM-0)
			y  80	$8000-$BFFF & $E000-$FFFF are mapped from $020000-$023FFF & $026000-$027FFF
			z  B1	$C000-$DFFF is unmapped (ROM-2 & I/O)

Return	   $00011C:	Contains the 4-byte MAP data to return to.  For example, if you're in the Monitor,
			this would contain BASIC's configuration.  When a mode is exited, this is the
			configuration that will be installed.

The "keystone" which hold the system together is a collection of Kernel routines contained in ROM at
$02C000-$02CFFF.  This section is never mapped, yet it always appears in every configuration because its
priority bit is always set in VIC register 48 (bit 5, ROM@C000).  The C64 configuration bits in the "4510"
port at $0001 are not used at all.
