CURSOR - Set cursor position, style, and turn it on or off

	      CURSOR [ON|OFF,] [column] [,row [,style] ]

The CURSOR command is used to turn the cursor ON or OFF, or specify its style
(0=flashing, 1=non-flashing).  You can also use CURSOR to place the cursor at
a particular place on the text display.  The next thing PRINTed or INPUT from
the display will start at this position.

The column and row parameters specify a new character position in the
currently defined screen window.  If either column or row is outside the
current window, an ILLEGAL QUANTITY ERROR is reported.  Use RWINDOW to
determine the screen size and current WINDOW dimensions.  Use RCURSOR to find
out where the cursor is.  In any case, column must be in the range of 0-39 for
40-column screens or 0-79 for 80-column screens.  Row must be in the range of
0-24.

	CURSOR ON		Turns cursor on at current position.
	CURSOR ON, 20		Turns cursor on in column 20 on the
				current line.  The next item printed
				or input will start here.
	CURSOR 0,24		Moves cursor to beginning of last line.
				The next item printed or input will start
				here.  If the cursor was on, it's still on,
				and if it was off, it's still off.
	CURSOR ,,1		Changes to solid cursor without moving it.

Note: because the C64DX screen editor uses a "software" cursor, you must make
sure the cursor is OFF before moving it or printing anything.  If you don't,
you risk leaving images of the cursor behind.  When a BASIC program is running,
the cursor is normally off except when processing an INPUT statement.  The
example below illustrates the proper way to program the cursor.  This program
simply echos whatever you type onto the screen.  Press the ESCAPE key to exit:

    10 DO: CURSOR ON: GET A$: CURSOR OFF: PRINT A$;: LOOP UNTIL A$=CHR$(27)

If you simply want to PRINT some text at a particular location, use:

	CURSOR col,row: PRINT "message"

If you want to INPUT some text from a particular location, use:

	CURSOR col,row: INPUT x$
