A.      The C64dx computer includes a built-in 3.5" disk drive, which has a
        capacity of 1 megabyte (unformated), and a versatile Disk Operating
        System. The C64dx DOS is conceptualy similar to the past Commodore
        disk drives, and file systems, but there are some important diffrences
        and many useful enhancements. Users familiar with the Commodore C128D
        computer, and the 1581 disk drive, along with the older PET dual drive 
        systems will recognize many similarities in the C64dx DOS, the 
        computers operating system (known as the "KERNAL"), along with the new 
        BASIC 10 DOS commands .

        In addition to supporting the built in disk drive, the C64dx supports 
        a variety of Commodore serial bus drives, including the 1540, 1541-II,
        1570, 1571, and 1581 drives, and implements both standard serial bus
        (for the 1540, 1541, and 1541-II drives), and fast serial bus 
        protocall (for the 1570, 1571, and 1581 drives). 

        Commodore disk drives when used with the serial bus, unlike those used 
        with most other computers, are "INTELLIGENT", which means they contain
        there own microprocessor which gives them the ability to execute 
        commands once issued from the computer.

        In the C64dx operating system, it has the ability to distinguish 
        between the serial bus "INTELLIGENT" disk drives, and the built in 
        internal, or external (1565) disk drive, and will use the proper
        communication protocall required for the particular disk drive.

        The following chapters will explain how to use the BASIC 10 DOS 
        commands, the features of the built in DOS, and the Commodore file
        operating systems. While the built in DOS is used by both the C64 and 
        the C64dx modes, the information provided will mostly pertain to the
        C64dx mode.


C.

Diskette Directory

        Just as a file cabinet contains diffrent file folders, your diskette 
can contain diffrent "file folders" of programs, or data files. These "file 
folders" are refered too as FILENAMES, as you progress further into using your 
C64dx computer you will become more familiar with this method of cataloguing 
your files. 

        There are several diffrent methods you can use to obtain a list
of filenames that your diskette contains on it.

        The first method will not erase anything in the C64dx's memory. With
this method, you can call up a directory anytime even in the middle of a 
program. To use this method, type the word DIR on a blank line and press the
RETURN key. You could also simply press the F3 key on the keyboard.

        The second method WILL erase anything in the computer's memory. (this
method MUST be used in the C64 mode). To see a list of files on you diskette 
using this method, first type:

                        LOAD"$",8

        The cursor will disappear during this process. When the cursor 
reapears, type: 
                        LIST

        If the directory is too large to fin on the screen at one time, it 
will scroll until it reaches the last entry. If you want to pause, stop or
slow down the scrolling, use one of the following methods:

TO STOP THE SCROLLING    - In the C64dx mode holding down the CTRL then 
pressing the S key will pause the display. You can also just press the NO 
SCROLL key which will simplify the process. To have the listing continue just 
press any other key or press the NO SCROLL key again. 

        In the C64 mode there is no way to stop the scrolling process, with
the exception of pressing the RUN/STOP key which will aboart the listing
process. To restart the listing just type LIST and press the RETURN key.

TO SLOW DOWN THE SCROLLING - In the C64dx mode, just hold down the Commodore 
key (C=). In the C64 mode, hold down the CTRL key.
D.

                PATTERN MATCHING

        One of the most powerful capabilities at your finger tips which 
surpasses most other computers, is the ability of using diffrent patterns to
access a file or to obtain a directory listing of a filenames.

        When using the built in enternal, or 1561 external disk drives, you 
have a much more



                BLOCK STATUS

        The BLOCK-STATUS command is used to obtain the free, used status
of a specified block.

FORMAT FOR BLOCK-STATUS COMMAND

        PRINT#15,"BLOCK-STATUS";drive#;channel#,track#;sector#

abbreviated as:PRINT#15,"B-S";drive#;track#;sector#

where "drive#" is the drive number, "channel#" is the channel number 
specified when the file reserving the buffer was opened, and "track#" and 
"sector#" are respectively the track and sector numbers of the desired block 
you wish to obtain the status of. 

EXAMPLE:
        To obtain the status of which we wrote our name in the BLOCK WRITE
example, and allocated in the first BLOCK-ALLOCATE example, we could use the
following simple program:

        10 OPEN2,8,2,"#"        :REM GET US AN INTERNAL CHANNEL
        20 OPEN15,8,15          :REM OPEN THE COMMAND CHANNEL
        30 PRINT#15,"B-S";0;1;1 :REM SEND OUT THE BLOCK STATUS COMMAND
        40 GET#2,A$             :REM GET THE BLOCK STATUS
        50 IF ASC(A$)=1 THEN PRINT "USED"
        60 IF ASC(A$)=0 THEN PRINT "FREE"
        70 DCLOSE

NOTE: The above command is only valid when using the internal, and external
C64DX computer, and will create a syntax error message when using any other
disk drive.





USER COMMANDS

     The C64DX built in Disk Operating System has several new capabilities 
built in than can be accessed thru the USER COMMANDS. The following method is 
used to use one of these enhanced capabilities. NOTE: These user command ONLY 
apply to the built in C64DX disk operating system, consult any other disk 
drives user manual before using one of the commands on that disk drive. 

User Command                                    Function
                                                                            
u0              Restores the system to this default jump table
u0>             See chapter ???????????? for more details.
ua              Block read replacement see chapter ??? for more details.
ub              Block write replacement see chapter ??? for more details.
uc thru uh      Are not used and will cause a SYNTAX ERROR message to be
                 returned by the dos.
ui              Soft reset the disk drive
uj              Hard start the disk drive (just like turning on the computer).
uk              Restore a disk after doing a short new command
ul              Compress this disk's directory sector by removing any unused
                gaps in the directory sector
um thru uo      Are not used and will cause a SYNTAX error message to be 
                returned by the DOS.

     This table is just a list of "addresses" of where the program is located
in the disk operating systems rom that the user wishes to execute. You can now
easily change this vector to point to another user jump table supplied by 
you, or another programer by sending out the following command over the 
command channel: 

        PRINT#15,"u0"chr$(lsb)chr$(msb)

   To use one of the aforementioned user commands enter the following 
statement:

        OPEN15,8,15,"Ux"
  
   Where x is one of the letters listed above under the user command column.


                ENHANCE DISK COMMANDS FOR THE C64DX COMPUTER

        Your new C64DX computer has had several new commands added to it's
operating system that other Commodore disk drives has not had in the past. In
this section we will be guiding you thru the use of these new commands.

FILE HANDLING COMMANDS

        There are three new commands which were added to aid in handling 
filename attributes, and the are: FILE LOCK, FILE UNLOCK, FILE RESTORE. These 
new commands allow you to SCRATCH proof a file (lock it out), and to unlock it
to allow you to scratch the file. The last one - File restore will allow you 
to restore a file after it has been scratched from the directory. NOTE: The 
FILE RESTORE command will only work if the file was scratched while the 
diskette was inserted into the internal disk drive, or the external 1561 disk 
drive. All three of these commands MUST be sent out over the command channel, 
and the syntax of these new commands are as follows;

        FILE LOCK

         OPEN15,DV,15,"F-LDRIVE:FILENAME"

        FILE UNLOCK

        OPEN15,DV,15,"F-UDRIVE:FILENAME"

        FILE RESTORE

        OPEN15,DV,15,"F-RDRIVE:FILENAME"

        After executing one of the aforementioned commands read the error 
channel to find out how many file's were locked, unlocked, or restored. You 
can have up to five filenames in one command aslong as they are seperated by
commas, and you can use wild cards (? and *) in the filenames any where you
desire.

        Please note that "DRIVE", is the drive number your disk is in that you
wish to execute the command on (0 is internal, 1 is the external 1561). You 
can also place the device number where "DV" is located in the open statement,
currently 8 is the internal, and the 1561 is the external disk drive.


