  C64DX				*** UPDATE ***		     F.BOWEN  4/17/91


	The following changes/updates/fixes have been made to the C64DX ROM
	code since the March 1, 1991 C64DX System Specification was printed.
	Please make note of them.  Current ROM as of this update is 910417.


	CHAR		Now works to spec and supports the following imbedded
			control characters (although some are buggy; others
			are planned):

			^F	 6	flip
			^I	 9	invert
			^O	15	overwrite
			^R	18	reverse field on
			 _	146	reverse field off
			^U	21	underline
			^X	24	xor
			^Y	25	tilt
			^Z	26	mirror

			When specifying a character set from ROM, note that
			national versions of the C64DX will have the national
			character set at $39000 and the C64 character set at
			$3D000.  In US/English systems, the default C64DX-mode
			character set will be at $39000.


	CLR ERR$	Clears BASIC error stuff, useful after a TRAP


	CURSOR [<ON|OFF>,] [column] [,row] [,style]
		where:	column,row = x,y logical screen position
			style      = flashing (0) or solid (1)
			ON,OFF     = to turn the cursor on or off


	LINE   x0, y0 [,[x1] [,y1]]...	
		where:	(x1,y1)=(x0,y0) if not specified, drawing a dot.
			Additional coordinates (x2,y2), etc. draw a line from
			the previous point.


	LOADIFF "file" [,U#,D#]
			Loads an IFF picture from disk.  Requires a suitable
			graphic screen to be already opened (this may change).
			The file must contain std IFF data in PRG file type.
			IFF pics can be ported directly from Amiga (eg., using
			XMODEM).  Returns 'File Data Error' if it finds data
			it does not like.

					
	MOD (number, modulus)
			New function.


	MOUSE  ON  [,[port] [,[sprite] [,[hotspot] [,X/Yposition] ]]]
	MOUSE  OFF
		where:	port     = (1...3) for joyport 1, 2, or either (both)
			sprite   = (0...7) sprite pointer
			hotspot  = x,y offset in sprite, default 0,0
			position = normal, relative, or angluar coordinates
			Defaults to sprite 0, port 2, last hotspot (0,0), and
			position.  Kernel doesn't let hotspot leave the screen.


	PAINT  x, y [,color]
			Working, but not completely to spec.  Uses draw pen
			color and fills emptyness to any border.


	RND(0)		Improved for better "randomness".  Uses unused POT
			of second SID chip.  PCB must allow lines to float.


	SET DISK #	(without [TO #] parameter) allows user to clear DS$
			message and specify which drive next DS$ comes from.





    *	Negative Coordinates are now allowed for all graphics commands.  Some
	commands require their arguments to be "onscreen", such as PAINT.


    *	BASIC errors now force text mode, and TYPE, LIST, DISK, KEYLOAD,
	LOADIFF now catch all DOS errors.  Autoboot filename= AUTOBOOT.C64DX.*


    *	Opening an RS-232 channel, command string allows setting new features:

		1	baud (0-16, where 16=MIDI rate)
		2	word len
		3	parity
		4	stop bits (not used)
		5	duplex
		6	xline
		7	xon char  (0=incoming flow control disabled)
		8	xoff char (0=outgoing flow control disabled)
		9,10	input  buffer pointer (page lo, hi)
		11,12	output buffer pointer (page lo, hi)
		13	high water mark (point at which xoff is xmitted)
		14	low  water mark (point at which xon  is xmitted)

	For debug purposes, the border color will change if an RS232 buffer
	overflow occurs.  To differentiate between a GET# of a null and a
	'no data' null, test bit 3 of STatus (same as C64).


    *	Support for latest DOS controller chip, F011D, includes error LED
	blink (border color still changes too, for now).  Changes to improve
	FASTLOAD speed and improve SAVE speed.  Will work with F011C chip,
	but error LED does not blink.  Requires latest 'ELMER' PAL for disk
	LED to work correctly for either controller chip.  External drive LED
	will not work correctly until new PCB & F016 chip are designed.  New
	DOS functions include COPY D0 TO D1, ability to change sector skews
	for files (U0>S#) and directory (U0>D#), and directory compress
	(i.e., empty trash) via "E" command.


    *	The DOS COPY/CONCAT bugs have been fixed, and COPY now allows forms
	such as COPY D0,"*.SRC" TO D1,"*".


    *	The Monitor parser now allows PETSCII input/conversion:

		'A			prints ASC() value of character
		>1800 'text		puts text into memory
		LDA #'A


    *	IRQ runs during graphics (Kernel finds its own base page).  IRQ
	still does not run during DOS activity (not sure if they ever will).
  C64DX				*** UPDATE ***		     F.BOWEN  4/17/91

    *	The following Kernel Jump Table Entries have moved (and are still
	subject to further changes):

		FF05	nirq		;IRQ handler
		FF07	monitor_brk	;BRK handler (Monitor)
		FF09	nnmi		;NMI handler
		FF0B	nopen		;open
		FF0D	nclose		;close
		FF0F	nchkin		;chkin
		FF11	nckout		;ckout
		FF13	nclrch		;clrch
		FF15	nbasin		;basin
		FF17	nbsout		;bsout
		FF19	nstop		;stop key scan
		FF1B	ngetin		;getin
		FF1D	nclall		;clall
		FF1F	monitor_parser	;monitor command parser
		FF21	nload		;load
		FF23	nsave		;save

		FF25	talk
		FF27	listen
		FF29	talksa
		FF2B	second
		FF2D	acptr
		FF2F	ciout
		FF31	untalk
		FF33	unlisten

		FF35	DOS_talk
		FF37	DOS_listen
		FF39	DOS_talksa
		FF3B	DOS_second
		FF3D	DOS_acptr
		FF3F	DOS_ciout
		FF41	DOS_untalk
		FF43	DOS_unlisten

		FF45	Get_DOS
		FF47	Leave_DOS
		FF49	ColdStartDOS		<<< new
		FF4B	WarmStartDOS		<<< new
