PIXEL - Get the color of a graphic pixel

			PIXEL (x,y)

The PIXEL function returns the color index of a pixel (dot) at a given x,y
location on the current drawscreen.  The x,y location is clipped to the
dimensions of the drawscreen; the function returns a value of zero for any
location out of bounds.

		c = PIXEL(x,y)
		IF c=0 THEN PRINT x,y;"is background color"







RCOLOR - Get text screen colors

			RCOLOR (n)

This function returns the color index of an area of the screen.  The
argument n identifies the area:

		 0 =	BACKGROUND color (text or graphic screen)
		 1 =	FOREGROUND color (text)
		 2 =	HIGHLIGHT color  (text)
		 3 =	BORDER color     (text or graphic screen)







RPALETTE - Get the R,G,B components of a defined color

		RPALETTE (screen, color, rgb)

This function returns the Red (rgb=0), Green (rgb=1), or Blue (rgb=2) component
of a color (0-255) defined by a PALETTE statement for a particular graphic
screen (0-3).

	...					assume screen has been opened
	 50 PALETTE 1, 2, 15,10,8		defines color #2 of screen #1
	 60 FOR I= 0 to 2			display rgb values of
	 70	PRINT I, RPALETTE(1,2,I)	screen #1 color #2
	 80	NEXT
	...					etc.

	 0	15
	 1	10
	 2	8

It cannot read the hardware palette, so it cannot return the components of a
text screen color or a color set by the PALETTE COLOR statement.  If a color
has not been previously defined, the values returned are meaningless.  The
RPALETTE function is useful for copying a palette from one screen to another.







RPEN - Return the color of a drawscreen's PEN

			RPEN (pen)

This function returns the current color assignment of a drawpen (0-2).

	PEN 0,5:  PRINT RPEN(0)			put color#5 into drawpen #1

	 5					displays color of drawpen #1


RGRAPHIC - Get graphic screen status & parameters

			RGRAPHIC (screen, param)

The RGRAPHIC function returns information about the graphic environment.  The
screen number (0-3) identifies which graphic screen, and param specifies:

	0 screen status			(1=open, 0=closed, >1=invalid)
	1 width				(0=320, 1=640, 2=1280)
	2 height			(0=200, 1=400)
	3 depth				(1-8 bitplanes)
	4 bitplanes used		(bitmask)
	5 bank A blocks used		(bitmask)
	6 bank B blocks used		(bitmask)
	7 current drawscreen number	(0-3, 255=text)
	8 current viewscreen number	(0-3, 255=text)

RGRAPHIC should be used after a SCREEN OPEN to tell if the screen was opened
properly before attempting to define its palette or draw upon it.

	10 SCREEN DEF  1,1,0,2			define screen #1 as 640x320x2
	20 SCREEN OPEN 1			open screen #1
	30 IF RGRAPHIC(1,0)<>1 THEN BEGIN
	40	PRINT"SCREEN OPEN FAILED!"	probably insufficient memory
	50	STOP
	60	BEND
	70 FOR I=0 TO 8				display screen stats
	80	PRINT I, HEX$(RGRAPHIC(1,I))
	90	NEXT
	99 SCREEN CLOSE 1

The example above prints the following data if successful:

	 0	0001				screen is open
	 1	0001				screen is 640 wide
	 2	0000				screen is 320 high
	 3	0002				screen has 2 bitplanes
	 4	0006		(%00000110)	uses bitplanes 2 and 3
	 5	00C0		(%11000000)	uses $C000-$FFFF in bank 0
	 6	0030		(%00110000)	uses $8000-$BFFF in bank 1
	 7	0001				screen #1 is the drawscreen
	 8	00FF				text is the viewscreen

