Graphic Functions

The following BASIC 10.0 functions can be used to test and manipulate the
graphic environment.

Get the status of a graphic screen & examine its features:

		RGRAPHIC (screen, param)

where param =	0 open (1), closed (0), or invalid (>1)
		1 width				(0=320, 1=640, 2=1280)
		2 height			(0=200, 1=400)
		3 depth				(1-8 bitplanes)
		4 bitplanes used		(returns bit mask of 8K blocks)
		5 bank A blocks used		(returns bit mask of 8K blocks)
		6 bank B blocks used		(returns bit mask of 8K blocks)
		7 drawscreen #			(0-3)
		8 viewscreen #			(0-3)

The following example illustrates how to properly test to see if a SCREEN OPEN
command was successful:

		10 SCREEN DEF  1,horz,vert,bp
		20 SCREEN OPEN 1
		30 IF RGRAPHIC(1,0)<>1 THEN PRINT "SCREEN OPEN FAILED!"



Get the color of a given X,Y pixel location on the current draw screen:

		PIXEL (x,y)		where x & y are screen coordinates



Get the color of a PEN for the current draw screen:

		RPEN (pen)		where pen = 0,1,2


Get the R,G, or B component of a color from a graphic screen's palette:

		RPALETTE (screen#, color#, rgb)

where:		screen# = 0-3
		color#	= 0-maximum for screen (dependent upon # bitplanes)
		rgb	= 0(red), 1(green), or 2(blue)


Note regarding Bitplane Allocation:

BASIC 10.0 allocates bitplanes according to a block availability map which
it maintains.  You don't have any control over which bitplanes are allocated
or where a particular bitplane is located.  You can find out which bitplanes
are being used, and where they are, using the RGRAPHIC function.

Generally, BASIC 10.0 allocates bitplanes in binary order.  That means, for
example, that bitplane 2 would be set for colors 4, 5, 6, 7, 12, 13, 14, 15,
etc.  This is good to know if you are programming sprite priorities or
collisions.


