
                                    [1;4mCHAPTER 8[0m

                             [1;4mBASIC 10.0 ENCYCLOPEDIA[0m


[1mIntroduction[0m

This section lists all the BASIC 10.0 commands, statements, and functions in
alphabetical order.  It gives a complete list of the rules (syntax) of BASIC
10.0, along with a concise description and practical example of each command.

[1mTerminology[0m

The following terms are used in this section:

KEYWORDS, also called reserved words, appear in uppercase letters.  They are
the names of the commands, statements, and functions that make up the BASIC
10.0 language.  Keywords cannot be used as variable names, and variable
names cannot contain any keywords.  Keywords that you enter are converted by
the BASIC interpreter into one or two byte tokens to save time and space when
the program is run or saved to disk.  When you LIST a program, the computer
translates the tokens back into keywords for you to read.

ARGUMENTS, also called parameters, appear in lowercase letters.  Often they
are variable names, and supply additional information for the command to
operate upon, such as the name of a file, a device number, or a line number.

VARIABLE refers to any valid BASIC variable name such as  X, Y$, or Z%.

EXPRESSION means any valid BASIC expression.  An expression is usually
specified to be numeric (A+1, X AND 7, VAL(A$)+1),  logical or boolean
(Y<10, A=B),  or  string ("FAB"+CHR$(13), RIGHT$("123",2), A$+" ").

Generally, variables and expressions can be used interchangeably, but you must
be careful to use the correct type of variable or expression.

PROGRAM MODE, sometimes called RUN mode, is the state that BASIC is in when
it is running a program.  Otherwise, the BASIC interpreter is in DIRECT MODE,
also called command mode, in which commands are executed immediately after
you enter them.  Most commands may be used in either mode, but some commands
are permissible only in program mode and others only in direct mode.

[1mSyntax Conventions[0m

The syntax of each command presented in this section follows certain
guidelines designed to make it as clear as possible.  The following example
shows how a command's syntax will be described in the Encyclopedia:

      DOPEN# file,  {"filename" | (expression)}  [,Udevice] [,Ddrive]
      ______ ___________________________________ ____________________
        |                    |                             |
     keyword         required arguments           optional arguments

Various conventions and symbols are used to convey a command's syntax,
including the used of uppercase (capitalized) and lowercase (not capitalized)
letters and symbols such as [brackets], {braces}, and |vertical bars|.

Things that are capitalized are required parts of a command's syntax and must
be entered (but don't press the shift key when you type them), such as the
command itself.  Things that are not capitalized represent information which
you must supply when you use the command, such as filenames.

The following syntax notation is used in this section:

CAPS	   Items in capital letters must be typed as shown.  Don't used the
	   shift key to enter them, however.

lowercase  Items in lowercase letters must be supplied by you.

[ ]	   Items inside brackets are optional.  The brackets themselves are
	   not to be entered.

{ }	   Items inside braces indicate that you have a choise between two or
	   more items, and you must select one of them.  You cannot select more
	   than one item.  The braces themselves are not to be entered.

|	   A vertical bar separates items in a list of options.  It means "or",
	   and implys you may select one item or another, but never more than
	   one.  The vertical bar is not part of the syntax.

...	   Three dots in a row are called an ellipsis.  It means the preceding
	   item may be repeated any number of times if you want to.  The
	   ellipsis is not part of the syntax.

All other punctuation including commas, colons, semicolons, (parenthesis), and
"quotation" marks are required parts of the syntax, and must be entered where
shown.
