MOUSE - Enable or disable the Mouse driver

	MOUSE  ON  [,[port] [,[sprite] [,[hotspot] [,position] ]]]
	MOUSE  OFF

	port     = joyport 1, 2, or either			(1-3)
	sprite   = number of sprite to use for pointer		(0-7)
	hotspot  = x,y pixel offset in sprite
	position = initial placement of pointer using
		   normal, relative, or angluar coordinates

The MOUSE ON command enables the built-in mouse driver, which requires an
optional 1351 mouse.   The MOUSE ON command defaults to port 2, sprite 0.
You must design and load your own sprite pointer data into the approprite
sprite data area ($600-$7FF).  See BLOAD and DMA.  Specify the sprite's
color and modes with the SPRITE command.

You can have a mouse device installed in either port, but not both ports at
the same time.  It's more efficient to specify a particular port (1 or 2).
Port 2 is recommended, since the mouse buttons won't interfere with keyboard
operations.

The hotspot is a dot in the sprite which the driver will always keep on the
screen.  The system initializes the hotspot to (0,0), the top left corner of
the 24x21 pixel sprite.  If you don't specify the hotspot, whatever was used
previously will be used.  The hotspot serves no other purpose.  

The position is an X,Y pixel location indicating where to initially place the
sprite's hotspot.  Note that MOUSE position, like MOVSPR, refers to the VIC
sprite 320x200 pixel coordinate plane regardless of screen resolution.

Note that the SPRITE and MOVSPR commands will affect the active pointer sprite,
and should be avoided except to set or change the pointer's color and mode.

The MOUSE OFF command will disable the built-in mouse driver and turn off
the pointer sprite.

10 DMA 0,64,DEC("8200"),2,DEC("600"),0		copy built-in sprite pointer
						(an arrow) to sprite-0 area
20 SPRITE 0,,2, 0, 0, 0, 0			make sprite#0 red, let it have
						priority over screen data, be
						unexpanded, and hires
30 MOUSE ON, 2, 0, 0,0, 100,100			turn on driver using port-2,
						sprite-0, putting the hotspot
						at 0,0, and placing it at
						location 100,100 on the screen

Use the RMOUSE function to read the mouse's current position and button status.
