MOVSPR - Move a sprite

	MOVSPR sprite, position [ TO position, speed ]
					
The MOVSPR command is used to place a sprite on the screen and optionally to
specify how it is to be moved by a background task.  Sprites will not be
visible until they are turned on (see SPRITE).  Once a sprite is set in
motion, the BASIC program will continue on while the system moves the sprite
according to the directions given.

	sprite   =	sprite number	(0-7)
	position =	where to place sprite, using one of these notations:

		  X,Y			absolute pixel location
		  {+|-}X, {+|-}Y	offset from current location
		  distance ; angle	relative to current location
		  angle # speed		start or stop constant motion

Absolute and relative coordinate refer to the VIC sprite coordinate plane,
which is always 320x200 regardless of screen resolution.  The sprite plane's
first visible pixel is 24,50, which corresponds to screen plane 0,0.  This
allows an unexpanded sprite to be positioned offscreen in either X or Y
and gradually scrolled into the visible area.

Angles are specified in clockwise degrees (0-360), where 0 is up, 90 is right,
180 is down, and 270 is left.  Speeds are specifed in number of pixels per
frame (there are 60 frames per second NTSC, 50 frames per second PAL), and
limited to the range 0-63.

A sprite's motion can be defined before it's turned on; a sprite won't move
until it is turned on.  If you used the MOVSPR TO syntax, you cannot use the
angle#speed notation.  To stop a moving sprite, specify a speed of 0.  Use
the RSPPOS function to get a sprite's current location and speed.  Use the
COLLISION statement and BUMP function to detect sprite-to-sprite or sprite-to-
data collisions.

	SPRITE 0,1: MOVSPR 0, 100,100		turn on sprite-0 and place it
						at sprite coordinates 100,100

	MOVSPR 1, 50,100 TO 300,100, 5		move sprite-1 from 50,100 to
						300,100 at 5 pixels per frame

	MOVSPR 2, +10,+5			move sprite-2 ten pixels to
						the right and five pixels down
						from its current position

	MOVSPR 3, 10;90				move sprite-3 ten pixels at an
						angle of 90 from its current
						position

	MOVSPR 4, 100,100: MOVSPR 4,10#5	first put sprite-4 at 100,100
						then set it in constant motion
						at an angle of 10 and speed of
						5.  Sprite will keep moving and
						wrap around the screen until
						it's explicitly stopped.

	MOVSPR 4, 0#0				stop sprite-4
