System Specification for C65		Fred Bowen		April 30, 1991


	3.1.4	[1;4mVARIABLES [0m-

     The C64DX uses three types of variables in BASIC:

		floating point		X
		integer			X%
		string			X$

     Normal NUMERIC VARIABLES, also called floating point variables, can
have  any   from  up  to  nine  digits of accuracy.  When a number
becomes larger than nine digits can show, as in +10 or -10, the computer
displays it in scientific notation form, with the number normalized to 1
digit and eight decimal places, followed by the letter E and  the  power
of  ten  by  which  the  number  is multiplied.  For example, the number
12345678901 is displayed as 1.23456789E+10.

     INTEGER VARIABLES can be used when the number  is  a  signed  whole
number  from  +32767 to -32768.  Integer data is a number like 5, 10, or
-100.  Integers take  up  less  space  than  floating  point  variables,
particularly when used in an array.

     STRING VARIABLES are those  used  for  character  data,  which  may
contain  numbers,  letters,  and  any other character that the computer
can make.  An example of string data is "Commodore C64DX".

     VARIABLE NAMES may consist of a single letter, a letter followed by
a  number,  or  two  letters.   Variable  names  may  be  longer  than 2
characters, but only the first  two  are  significant.   An  integer  is
specified by using the percent (%) sign after the variable name.  String
variables have a dollar sign ($) after their names.

                        EXAMPLES:
                Numeric Variable Names:  A, A5, BZ
                Integer Variable Names:  A%, A5%, BZ%
                String Variable Names:   A$, A5$, BZ$

     ARRAYS are lists of variables with the same name,  using  an  extra
number  (or  numbers)  to  specify  an element of the array.  Arrays are
defined using the DIM statement, and may be floating point, integer,  or
string variable arrays.  The array variable name is followed by a set of
parentheses () enclosing the number of the variable in the list.

                        EXAMPLE:
                A(7), BZ%(11), A$(87)

     Arrays can have more than one dimension.  A two  dimensional  array
may  be  viewed  as  having  rows  and  columns,  with  the first number
identifying the row and the second number identifying the column (as  if
specifying a certain grid on the map).

                        EXAMPLE:
                A(7,2), BZ%(2,3,4), Z$(3,2)

     RESERVED VARIABLE NAMES are names that are reserved for use by  the
computer, and may not be used for another purpose.  These are the variables
DS, DS$, ER, ERR$, EL, ST, TI, and TI$.  KEYWORDS such as TO and  IF  or
any  other names that contain KEYWORDS, such as RUN, NEW, or LOAD cannot
be used.

     ST is a  status  variable  for  input  and  output  (except  normal
screen/keyboard  operations).  The value of ST depends on the results of
the last I/O operation.  In general, if the value of ST is  0  then  the
operation was successful.

     TI and TI$ are variables that relate to the real-time  clock  built
into  the  C64DX.  The system clock is reset to zero when the system is
powered up or reset, and can be changed by the user or a program.

    TI$="hh:mm:ss.t"  Allows optional colons to delimit parameters and
		      allows input to be abbrieviated (eg., TI$="h:mm" or
		      even TI$=""), defaulting to "00" for unspecified
		      parameters.  24-hour clock (00:00:00.0 to 23:59:59.9).

    TI  	     24-hour TOD converted into tenths of seconds.

     The value of the clock is lost when the computer is  turned  off.   It
starts  at  zero  when the computer is turned on, and is reset to zero when
the value of the clock exceeds 23:59:59.9 .

     The variable DS reads the disk drive command channel,  and  returns
the  current  status  of  the  drive.  To get this information in words,
PRINT DS$.  These status variables are used after a disk operation, like
a  DLOAD or DSAVE, to find out why the error light on the disk drive
is blinking.

     ER, EL, and ERR$ are variables used  in  error  trapping  routines.
They  are  usually  only  useful  within a program.  ER returns the last
error encountered since the program was RUN.  EL is the line  where  the
error occurred.  ERR$ is a function that allows the program to print one
of the BASIC error messages.  PRINT ERR$(ER) prints out the proper error
message.

System Specification for C65		Fred Bowen		April 30, 1991


	3.1.5	[1;4mOPERATORS [0m-

     The BASIC OPERATORS include  ARITHMETIC,  RELATIONAL,  and  LOGICAL
OPERATORS.  The ARITHMETIC operators include the following signs:

                +   addition
                -   subtraction
                *   multiplication
                /   division
                ^   raising to a power (exponentiation)

     On a line containing more than one operator, there is a  set  order
in  which  operations  always  occur.   If  several  operators  are used
together,  the  computer  assigns   priorities   as   follows:    First,
exponentiation, then multiplication and division, and last, addition and
subtraction.  If two operators have the same priority, then calculations
are  performed  in order from left to right.  If these operations are to
occur in a different order, BASIC 10.0  allows giving  a  calculation  a
higher  priority  by placing parentheses around it.  Operations enclosed
in parentheses will be calculated before any other operation.  Make sure
that  the  equations have the same number of left and right parentheses,
or a SYNTAX ERROR message is posted when the program is run.

     There are also operators for equalities  and  inequalities,  called
RELATIONAL  operators.   Arithmetic  operators always take priority over
relational operators.

                =               is equal to
                <               is less than
                >               is greater than
                <= or =<        is less than or equal to
                >= or =>        is greater than or equal to
                <> or ><        is not equal to

     Finally, there are three LOGICAL  operators,  with  lower  priority
than both arithmetic and relational operators:

                AND
                OR
                NOT

     These are most often used to join multiple formulas in IF ...  THEN
statements.   When  they  are  used  with arithmetic operators, they are
evaluated last (i.e., after + and -).  If the relationship stated in the
expression is the true the result is assigned an integer of -1 and
if false a of 0 is assigned.  There is also an XOR function.

                        EXAMPLES:

     IF A=B AND C=D THEN 100		requires both A=B & C=D to be true
     IF A=B OR C=D THEN 100		allows either A=B or C=D to be true
     A=5:B=4:PRINT A=B			displays  0
     A=5:B=4:PRINT A>3			displays -1
     PRINT 123 AND 15:PRINT 5 OR 7	displays 11 and 7

